diff -uNr src.ORIG/config/MacOSX.cf src/config/MacOSX.cf
--- src.ORIG/config/MacOSX.cf	2005-05-29 00:21:17.000000000 +0900
+++ src/config/MacOSX.cf	2005-05-29 00:20:25.000000000 +0900
@@ -143,6 +143,7 @@
 #define CERNLIB_PPC
 #define CERNLIB_QMGLIBC
 #define CERNLIB_MACOSX
+#define CERNLIB_GFORTRAN
 
 #define X11Includes             -I/usr/X11R6/include
 
diff -uNr src.ORIG/geant321/block/flkdt5.F src/geant321/block/flkdt5.F
--- src.ORIG/geant321/block/flkdt5.F	1995-10-24 19:19:36.000000000 +0900
+++ src/geant321/block/flkdt5.F	2005-05-29 02:38:22.000000000 +0900
@@ -91,7 +91,11 @@
 *     Particle  names                                                  *
       DATA ANAMZ1 /'NNPI', 'ANPPI', 'ANNPI', ' ETS  ',' PAP  ',' PAN  ',
      & 'APN', 'DEO   ', 'S+2030', 'AN*-14', 'AN*014','KONPI ','AKOPPI',
+#if !defined(CERNLIB_GFORTRAN)
      & 3*'BLANK' /
+#else
+     & 'BLANK', 'BLANK', 'BLANK' /
+#endif
 *     Name of decay channel                                            *
       DATA ZKNM41/'NNPI0','PNPI-','APPPI+','ANNPI+','ANPPI0','APNPI+',
      & 'ANNPI0','APPPI0','ANPPI-'/
@@ -116,7 +120,12 @@
      & 'APETA ','AN=P+ ','AN-PO ','ANOPO ','APRHOO','ANRHO-','ANETA ',
      & 'AN-P+ ','AN0PO ','AN+P- ','APRHO+','ANRHO0',
      & 'KONPIO','KOPPI-','K+NPI-','AKOPPO','AKONP+','K-PPI+',
+#if !defined(CERNLIB_GFORTRAN)
      & 9*'BLANK'/
+#else
+     & 'BLANK', 'BLANK', 'BLANK', 'BLANK', 'BLANK',
+     & 'BLANK', 'BLANK', 'BLANK', 'BLANK'/
+#endif
 *
       DO 10 J=1,16
          AMZ(J)=AMZ1(J)
diff -uNr src.ORIG/geant321/geocad/gweucl.F src/geant321/geocad/gweucl.F
--- src.ORIG/geant321/geocad/gweucl.F	1995-10-24 19:20:47.000000000 +0900
+++ src/geant321/geocad/gweucl.F	2005-05-29 02:50:05.000000000 +0900
@@ -308,7 +308,11 @@
       WRITE (CHMAIL,11200) FILEXT(1:IT+9)
       CALL GMAIL (1,1)
 *
+#if !defined(CERNLIB_GFORTRAN)
 10000 FORMAT (1H!,/,A,/,1H!)
+#else
+10000 FORMAT ('!',/,A,/,'!')
+#endif
 *
 10100 FORMAT ('TMED',2(1X,I3,1X,1H',A20,1H'))
 10200 FORMAT ('ROTM',1X,I3,6(1X,F8.3))
diff -uNr src.ORIG/geant321/gheisha/dlpnuc.F src/geant321/gheisha/dlpnuc.F
--- src.ORIG/geant321/gheisha/dlpnuc.F	1995-10-24 19:21:06.000000000 +0900
+++ src/geant321/gheisha/dlpnuc.F	2005-05-29 02:54:03.000000000 +0900
@@ -28,7 +28,17 @@
    10 L=LT(LEVEL)
       R=RT(LEVEL)
       LEVEL=LEVEL-1
+#if !defined(CERNLIB_GFORTRAN)
    20 IF(R.LE.L) IF(LEVEL) 50,50,10
+#else
+   20 IF(R.LE.L) THEN
+         IF(LEVEL.LE.0) THEN
+            GO TO 50
+         ELSE
+            GO TO 10
+         ENDIF
+      ENDIF
+#endif
 C
 C   SUBDIVIDE THE INTERVAL L,R
 C     L : LOWER LIMIT OF THE INTERVAL (INPUT)
diff -uNr src.ORIG/geant321/gheisha/dlpsor.F src/geant321/gheisha/dlpsor.F
--- src.ORIG/geant321/gheisha/dlpsor.F	1995-10-24 19:21:01.000000000 +0900
+++ src/geant321/gheisha/dlpsor.F	2005-05-29 02:56:18.000000000 +0900
@@ -31,7 +31,17 @@
    10 L=LT(LEVEL)
       R=RT(LEVEL)
       LEVEL=LEVEL-1
+#if !defined(CERNLIB_GFORTRAN)
    20 IF(R.LE.L) IF(LEVEL) 50,50,10
+#else
+   20 IF(R.LE.L) THEN
+         IF(LEVEL.LE.0) THEN
+            GO TO 50
+         ELSE
+            GO TO 10
+         ENDIF
+      ENDIF
+#endif
 C
 C   SUBDIVIDE THE INTERVAL L,R
 C     L : LOWER LIMIT OF THE INTERVAL (INPUT)
diff -uNr src.ORIG/geant321/peanut/bimsel.F src/geant321/peanut/bimsel.F
--- src.ORIG/geant321/peanut/bimsel.F	1997-10-17 19:00:03.000000000 +0900
+++ src/geant321/peanut/bimsel.F	2005-05-29 03:07:25.000000000 +0900
@@ -46,7 +46,7 @@
      &     AUSFL , ZUSFL , BNDSAV, RADHLP, BFCHLP, BIMCLM, PRCOLP,
      &     PRCOLN, IBTOLD, ICTOLD, KPROJ , NTRIAL, ITFRMI
       SAVE SBHAL0, SBSKI0, SBCEN0, SBCEN1, SBSKI1, SBHAL1
-#ifndef CERNLIB_WINNT
+#if !defined(CERNLIB_WINNT) && !defined(CERNLIB_GFORTRAN)
       SAVE
 #endif
       DATA IBTOLD, ICTOLD / 2*0 /
diff -uNr src.ORIG/geant321/peanut/pfnclv.F src/geant321/peanut/pfnclv.F
--- src.ORIG/geant321/peanut/pfnclv.F	1996-09-30 23:25:47.000000000 +0900
+++ src/geant321/peanut/pfnclv.F	2005-05-29 03:09:40.000000000 +0900
@@ -157,7 +157,11 @@
 *----------------------------------------------------------------------*
 *----------------------------------------------------------------------*
 *
+#if !defined(CERNLIB_GFORTRAN)
       ENTRY NCLVFX
+#else
+      ENTRY NCLVFX()
+#endif
       NCLVFX = PIPIPI
       DO 5000 N=1,NPRNUC
          I = IPRNUC (N)
diff -uNr src.ORIG/graflib/higz/ig/ighatc.F src/graflib/higz/ig/ighatc.F
--- src.ORIG/graflib/higz/ig/ighatc.F	1996-02-14 22:10:34.000000000 +0900
+++ src/graflib/higz/ig/ighatc.F	2005-05-29 01:11:02.000000000 +0900
@@ -69,7 +69,13 @@
       NTSAV=INTR
       CALL ISELNT(0)
 *
+#if !defined(CERNLIB_GFORTRAN)
       DO 70 YCUR=YMAX,YMIN,-DY
+#else
+      NY = (YMAX-YMIN)/DY
+      DO 70 IYCUR=0,NY
+         YCUR = YMAX - IYCUR*DY 
+#endif
          NBI=0
          DO 20 I=2,N+1
             I2=I
diff -uNr src.ORIG/graflib/higz/ikernel/iopks.F src/graflib/higz/ikernel/iopks.F
--- src.ORIG/graflib/higz/ikernel/iopks.F	2004-07-22 23:35:57.000000000 +0900
+++ src/graflib/higz/ikernel/iopks.F	2005-05-29 01:14:23.000000000 +0900
@@ -120,7 +120,11 @@
       CHARACTER*16 TCARD
 *
       CALL UHTOC(
+#if defined(CERNLIB_QRTHOLL)
      + 40HVERSION  1.29/04   10/06/04                 
+#else
+     + 'VERSION  1.29/04   10/06/04             '   
+#endif
 #if !defined(CERNLIB_CRAY)
      +,4,TCARD,16)
 #endif
diff -uNr src.ORIG/mathlib/gen/b/Imakefile src/mathlib/gen/b/Imakefile
--- src.ORIG/mathlib/gen/b/Imakefile	1996-05-01 22:21:33.000000000 +0900
+++ src/mathlib/gen/b/Imakefile	2005-05-29 02:06:28.000000000 +0900
@@ -1,11 +1,19 @@
 DoIncludePackage(gen)
 #include "pilot.h"
 
+#if !defined(CERNLIB_GFORTRAN)
 SRCS_F=	asinh64.F atg.F binom64.F dplnml.F prmfct.F rplnml.F rsrtnt64.F
+#else
+SRCS_F=	asinh64.F atg.F binom64.F dplnml.F prmfct.F rplnml.F
+#endif
 
 #if defined(CERNLIB_DOUBLE)
+#if !defined(CERNLIB_GFORTRAN)
 SRCS_F:= $(SRCS_F) asinh.F binom.F rsrtnt.F 
 #else
+SRCS_F:= $(SRCS_F) asinh.F binom.F
+#endif
+#else
 SRCS_F:= $(SRCS_F) asinh128.F binom128.F rsrtnt128.F
 #endif
 
diff -uNr src.ORIG/mathlib/gen/b/rsrtnt64.F src/mathlib/gen/b/rsrtnt64.F
--- src.ORIG/mathlib/gen/b/rsrtnt64.F	1996-04-02 00:01:51.000000000 +0900
+++ src/mathlib/gen/b/rsrtnt64.F	2005-05-29 01:42:41.000000000 +0900
@@ -117,7 +117,11 @@
         ENDIF
        ELSE
         IF(N .EQ. 1) THEN
+#if !defined(CERNLIB_GFORTRAN)
          ASSIGN 11 TO JMP1
+#else
+         JMP1 = 11
+#endif
          GO TO 10
    11    IF(K .EQ. 0) THEN
           H=H
@@ -174,13 +178,21 @@
            H=2*((H1+B*U)/RT(U)-(H1+B*V)/RT(V))/DELTA
            LB1=11
           ELSEIF(K .EQ. 2) THEN
+#if !defined(CERNLIB_GFORTRAN)
            ASSIGN 12 TO JMP1
+#else
+           JMP1 = 12
+#endif
            GO TO 10
    12      H1=DELTA-B**2
            H2=2*A*B
            H=(((H1*U-H2)/RT(U)-(H1*V-H2)/RT(V))/DELTA+H)/C
           ELSEIF(K .EQ. 3) THEN
+#if !defined(CERNLIB_GFORTRAN)
            ASSIGN 13 TO JMP1
+#else
+           JMP1 = 12
+#endif
            GO TO 10
    13      H1=C*DELTA
            G1=A*C
@@ -217,7 +229,11 @@
         ENDIF
        ELSE
         IF(N .EQ. 1) THEN
+#if !defined(CERNLIB_GFORTRAN)
          ASSIGN 21 TO JMP2
+#else
+         JMP2 = 21
+#endif
          GO TO 20
    21    IF(K .EQ. -1) THEN
           H=H
@@ -257,7 +273,11 @@
            IF(U. LT. -X0) H=-H
           ENDIF
          ELSE
+#if !defined(CERNLIB_GFORTRAN)
           ASSIGN 22 TO JMP2
+#else
+          JMP2 = 22
+#endif
           GO TO 20
    22     IF(K .EQ. -1) THEN
            H1=B*C
@@ -298,7 +318,17 @@
       ELSE
        H=(ASIN((C2*U+B)/RTD)-ASIN((C2*V+B)/RTD))/SQRT(-C)
       ENDIF
+#if !defined(CERNLIB_GFORTRAN)
       GO TO JMP1, (11,12,13)
+#else
+      if (jmp1 .eq. 11) then
+         go to 11
+      else if (jmp1 .eq. 12) then
+         go to 12
+      else if (jmp1 .eq. 13) then
+         go to 13
+      endif
+#endif
 
    20 IF(C .EQ. 0) THEN
        IF(B .EQ. 0) THEN
@@ -326,7 +356,15 @@
         IF(U .LT. 0 .AND. V .LT. 0) H=-H
        ENDIF
       ENDIF
+#if !defined(CERNLIB_GFORTRAN)
       GO TO JMP2, (21,22)
+#else
+      if (jmp2 .eq. 21) then
+         go to 21
+      else if (jmp2 .eq. 22) then
+         go to 22
+      endif
+#endif
 
     9 RES=SIGN(R1,V1-U1)*H
       LRL=LLL
diff -uNr src.ORIG/mathlib/gen/c/rexpin64.F src/mathlib/gen/c/rexpin64.F
--- src.ORIG/mathlib/gen/c/rexpin64.F	1997-09-04 21:10:28.000000000 +0900
+++ src/mathlib/gen/c/rexpin64.F	2005-05-29 02:12:24.000000000 +0900
@@ -117,7 +117,7 @@
        ENTRY REXPIE
 #endif
 #if defined(CERNLIB_DOUBLE)
-#  ifdef CERNLIB_MSSTDCALL
+#  if defined(CERNLIB_MSSTDCALL) || defined(CERNLIB_GFORTRAN)
        ENTRY DEXPIE(x)
 #  else
        ENTRY DEXPIE
diff -uNr src.ORIG/mathlib/gen/j/map.F src/mathlib/gen/j/map.F
--- src.ORIG/mathlib/gen/j/map.F	1996-04-02 00:02:51.000000000 +0900
+++ src/mathlib/gen/j/map.F	2005-05-29 02:17:20.000000000 +0900
@@ -69,13 +69,26 @@
        Y1=Y(I)
        YS=YS+Y1
        J=INT((Y1-YL)/YD)+2
+#if defined(CERNLIB_QRTHOLL)
       IF(YP.LT.0.) CALL VFILL(LINE(K),1,1H.)
       CALL VFILL(LINE(1),1,1HI)
+#else
+      IF(YP.LT.0.) CALL VFILL(LINE(K),1,'.')
+      CALL VFILL(LINE(1),1,'I')
+#endif
       LINE(103)=LINE(1)
        IF(MOD(N,10).NE.0)GO TO 12
+#if defined(CERNLIB_QRTHOLL)
       CALL VFILL(LINE(1),1,1H+)
+#else
+      CALL VFILL(LINE(1),1,'+')
+#endif
       LINE(103)=LINE(1)
+#if defined(CERNLIB_QRTHOLL)
    12 CALL VFILL(LINE(J),1,1H*)
+#else
+   12 CALL VFILL(LINE(J),1,'*')
+#endif
        WRITE(6,13)N,X,Y1,LINE
    13 FORMAT(I6,1X,2E10.3,2X,103A1)
    11 CALL VBLANK(LINE(J),1)
diff -uNr src.ORIG/mathlib/gen/m/sortdq.F src/mathlib/gen/m/sortdq.F
--- src.ORIG/mathlib/gen/m/sortdq.F	1996-04-02 00:02:51.000000000 +0900
+++ src/mathlib/gen/m/sortdq.F	2005-05-29 02:21:46.000000000 +0900
@@ -24,7 +24,17 @@
    10 L=LT(LEVEL)
       R=RT(LEVEL)
       LEVEL=LEVEL-1
+#if !defined(CERNLIB_GFORTRAN)
    20 IF(R.LE.L) IF(LEVEL) 90,90,10
+#else
+   20 IF(R.LE.L) THEN
+         IF(LEVEL.LE.0) THEN
+            GO TO 90
+         ELSE 
+            GO TO 10
+         ENDIF
+      ENDIF
+#endif
 C
 C   SUBDIVIDE THE INTERVAL L,R
 C     L : LOWER LIMIT OF THE INTERVAL (INPUT)
diff -uNr src.ORIG/mathlib/gen/m/sortiq.F src/mathlib/gen/m/sortiq.F
--- src.ORIG/mathlib/gen/m/sortiq.F	1996-04-02 00:02:51.000000000 +0900
+++ src/mathlib/gen/m/sortiq.F	2005-05-29 02:23:38.000000000 +0900
@@ -23,7 +23,18 @@
    10 L=LT(LEVEL)
       R=RT(LEVEL)
       LEVEL=LEVEL-1
+#if !defined(CERNLIB_GFORTRAN)
    20 IF(R.LE.L) IF(LEVEL) 90,90,10
+#else
+   20 IF(R.LE.L) THEN
+         IF(LEVEL.LE.0) THEN
+            GO TO 90
+         ELSE 
+            GO TO 10
+         ENDIF
+      ENDIF
+#endif
+
 C
 C   SUBDIVIDE THE INTERVAL L,R
 C     L : LOWER LIMIT OF THE INTERVAL (INPUT)
diff -uNr src.ORIG/mathlib/gen/m/sortrq.F src/mathlib/gen/m/sortrq.F
--- src.ORIG/mathlib/gen/m/sortrq.F	1996-04-02 00:02:52.000000000 +0900
+++ src/mathlib/gen/m/sortrq.F	2005-05-29 02:24:09.000000000 +0900
@@ -21,7 +21,18 @@
    10 L=LT(LEVEL)
       R=RT(LEVEL)
       LEVEL=LEVEL-1
+#if !defined(CERNLIB_GFORTRAN)
    20 IF(R.LE.L) IF(LEVEL) 90,90,10
+#else
+   20 IF(R.LE.L) THEN
+         IF(LEVEL.LE.0) THEN
+            GO TO 90
+         ELSE 
+            GO TO 10
+         ENDIF
+      ENDIF
+#endif
+
 C
 C   SUBDIVIDE THE INTERVAL L,R
 C     L : LOWER LIMIT OF THE INTERVAL (INPUT)
diff -uNr src.ORIG/mathlib/gen/v/v107z0.inc src/mathlib/gen/v/v107z0.inc
--- src.ORIG/mathlib/gen/v/v107z0.inc	2000-06-08 18:57:22.000000000 +0900
+++ src/mathlib/gen/v/v107z0.inc	2005-05-29 02:28:54.000000000 +0900
@@ -17,7 +17,11 @@
 *
 
 #if defined(CERNLIB_LNX)||defined(CERNLIB_ALLIANT)||defined(CERNLIB_DECS)||defined(CERNLIB_MACMPW)||defined(CERNLIB_SGI)
+#if !defined(CERNLIB_GFORTRAN)
       DATA IZ0/'33000000'X/
+#else
+      DATA IZ0/X'33000000'/
+#endif
 
 #elif defined(CERNLIB_APOLLO)
       DATA IZ0/16#33000000/
diff -uNr src.ORIG/mclibs/eurodec/fragmt/ordstk.F src/mclibs/eurodec/fragmt/ordstk.F
--- src.ORIG/mclibs/eurodec/fragmt/ordstk.F	1996-03-09 01:58:52.000000000 +0900
+++ src/mclibs/eurodec/fragmt/ordstk.F	2005-05-29 03:13:58.000000000 +0900
@@ -26,7 +26,17 @@
    10 L=LT(LEVEL)
       R=RT(LEVEL)
       LEVEL=LEVEL-1
+#if !defined(CERNLIB_GFORTRAN)
    20 IF (R.LE.L) IF (LEVEL) 80,80,10
+#else
+   20 IF (R.LE.L) THEN
+         IF (LEVEL.LE.0) THEN
+            GO TO 80 
+         ELSE 
+            GO TO 10
+         ENDIF
+      ENDIF
+#endif
 C--
 C--   SUBDIVIDE THE INTERVAL L,R
 C--   L : LOWER LIMIT OF THE INTERVAL (INPUT)
diff -uNr src.ORIG/mclibs/herwig/code/hwbcon.F src/mclibs/herwig/code/hwbcon.F
--- src.ORIG/mclibs/herwig/code/hwbcon.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbcon.F	2005-05-31 02:34:20.000000000 +0900
@@ -7,6 +7,9 @@
 C     MAKES COLOUR CONNECTIONS BETWEEN JETS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IHEP,IST,ID,JC,JD,JHEP,LHEP
       IF (IERROR.NE.0) RETURN
       DO 20 IHEP=1,NHEP
@@ -57,7 +60,12 @@
           JMOHEP(2,IHEP)=LHEP
         ELSE
 C---COULDN'T FIND PARTNER OF IHEP
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWBCON',100,*999)
+#else
+          call hwwarn('HWBCON',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
       ENDIF
   20  CONTINUE
diff -uNr src.ORIG/mclibs/herwig/code/hwbded.F src/mclibs/herwig/code/hwbded.F
--- src.ORIG/mclibs/herwig/code/hwbded.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbded.F	2005-05-31 02:34:39.000000000 +0900
@@ -8,6 +8,9 @@
 C     IF (IOPT.EQ.2) CLEAN UP EVENT RECORD AFTER SHOWERING
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWBVMC,HWRGEN,HWUALF,HWUSQR,X(3),W,WMAX,WSUM,
      & X1MIN,X1MAX,X2MIN,X2MAX,QSCALE,GAMFAC,GLUFAC,R(3,3),CS,SN,M(3),
      & E(3),LAMBDA,A,B,C,PTSQ,EM,P1(5),P2(5),PVRT(4),EPS,MASDEP
@@ -22,8 +25,14 @@
         IF (EMIT.NE.0) RETURN
         ICMF=0
         DO 10 IHEP=1,NHEP
+#if !defined(CERNLIB_GFORTRAN)
  10       IF (ICMF.EQ.0 .AND. ISTHEP(IHEP).EQ.110 .AND.
      &    JDAHEP(2,IHEP).EQ.JDAHEP(1,IHEP)+1) ICMF=IHEP
+#else
+             IF (ICMF.EQ.0 .AND. ISTHEP(IHEP).EQ.110 .AND.
+     &    JDAHEP(2,IHEP).EQ.JDAHEP(1,IHEP)+1) ICMF=IHEP
+ 10       continue
+#endif
         IF (ICMF.EQ.0) RETURN
         EM=PHEP(5,ICMF)
         IF (EM.LT.2*HWBVMC(1)) RETURN
@@ -225,6 +234,11 @@
  410    CONTINUE
         EMIT=0
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWBDED',500,*999)
+#else
+        call hwwarn('HWBDED',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
  999  END
diff -uNr src.ORIG/mclibs/herwig/code/hwbdis.F src/mclibs/herwig/code/hwbdis.F
--- src.ORIG/mclibs/herwig/code/hwbdis.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbdis.F	2005-05-31 02:34:39.000000000 +0900
@@ -9,6 +9,9 @@
 C     IF (IOPT.EQ.2) CLEAN UP EVENT RECORD AFTER SHOWERING
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWBVMC,HWUALF,HWULDO,P1(5),P2(5),P3(5),
      & PCMF(5),L(5),R(3,3),Q,XBJ,RN,XPMIN,XPMAX,XP,ZPMIN,ZPMAX,ZP,FAC,
      & X1,X2,XTSQ,XT,PTSQ,SIN1,SIN2,W1,W2,CFAC,PDFOLD(13),PDFNEW(13),
@@ -27,8 +30,14 @@
         IF (EMIT.EQ.NEVHEP+NWGTS) RETURN
         ICMF=0
         DO 10 IHEP=1,NHEP
+#if !defined(CERNLIB_GFORTRAN)
  10       IF (ICMF.EQ.0 .AND. ISTHEP(IHEP).EQ.110 .AND.
      &    JDAHEP(2,IHEP).EQ.JDAHEP(1,IHEP)+1) ICMF=IHEP
+#else
+             IF (ICMF.EQ.0 .AND. ISTHEP(IHEP).EQ.110 .AND.
+     &    JDAHEP(2,IHEP).EQ.JDAHEP(1,IHEP)+1) ICMF=IHEP
+ 10       continue
+#endif
         IF (ICMF.EQ.0) RETURN
         IIN=JMOHEP(2,ICMF)
         IOUT=JDAHEP(2,ICMF)
@@ -157,7 +166,12 @@
         ISTAT=7
         CALL HWSFUN(XBJ,Q,IDHW(IHAD),NSTRU,PDFOLD,2)
         ISTAT=ITEMP
+#if !defined(CERNLIB_GFORTRAN)
         IF (PDFOLD(ID).LE.0) CALL HWWARN('HWBDIS',100,*999)
+#else
+        IF (PDFOLD(ID).LE.0) call hwwarn('HWBDIS',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
         IF (XP.GT.XBJ) THEN
           CALL HWSFUN(XBJ/XP,SCALE,IDHW(IHAD),NSTRU,PDFNEW,2)
           FAC=CFAC/(2*PIFAC) * HWUALF(1,SCALE) * FAC *
@@ -466,6 +480,11 @@
      $       CALL HWVZRO(4,VHEP(1,JDAHEP(1,IOUT)+1))
         EMIT=0
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWBDIS',500,*999)
+#else
+        call hwwarn('HWBDIS',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
  999  END
diff -uNr src.ORIG/mclibs/herwig/code/hwbfin.F src/mclibs/herwig/code/hwbfin.F
--- src.ORIG/mclibs/herwig/code/hwbfin.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbfin.F	2005-05-31 02:34:20.000000000 +0900
@@ -8,6 +8,9 @@
 C     AND COPIES INTO /HEPEVT/ IN COLOUR ORDER.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IHEP,ID,IJET,KHEP,IPAR,JPAR,NXPAR,IP,JP
       IF (IERROR.NE.0) RETURN
 C---SAVE VIRTUAL PARTON DATA
@@ -60,7 +63,12 @@
       ENDIF
    10 CONTINUE
 C---COULDN'T FIND COLOUR PARTNER
+#if !defined(CERNLIB_GFORTRAN)
       CALL HWWARN('HWBFIN',1,*999)
+#else
+      call hwwarn('HWBFIN',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
    15 JPAR=JCOPAR(1,IPAR)
       KHEP=KHEP+1
       ID=IDPAR(IPAR)
diff -uNr src.ORIG/mclibs/herwig/code/hwbgen.F src/mclibs/herwig/code/hwbgen.F
--- src.ORIG/mclibs/herwig/code/hwbgen.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbgen.F	2005-05-31 02:34:39.000000000 +0900
@@ -9,6 +9,9 @@
 C     G.MARCHESINI & B.R.WEBBER, NUCL. PHYS. B238(1984)1
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWULDO,HWRGAU,EINHEP,ERTXI,RTXI,XF
       INTEGER NTRY,LASHEP,IHEP,NRHEP,ID,IST,JHEP,KPAR,I,J,IRHEP(NMXJET),
      & IRST(NMXJET)
@@ -17,7 +20,14 @@
       IF (IERROR.NE.0) RETURN
       IF (IPRO.EQ.80) RETURN
 C---CHECK THAT EMSCA IS SET
+#if !defined(CERNLIB_GFORTRAN)
       IF (EMSCA.LE.ZERO) CALL HWWARN('HWBGEN',200,*999)
+#else
+      if (EMSCA.LE.ZERO) then
+          call hwwarn('HWBGEN',200,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       IF (HARDME) THEN
 C---FORCE A BRANCH INTO THE `DEAD ZONE' IN E+E-
         IF (IPROC/10.EQ.10) CALL HWBDED(1)
@@ -27,7 +37,14 @@
       NTRY=0
       LASHEP=NHEP
    10 NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
       IF (NTRY.GT.NETRY) CALL HWWARN('HWBGEN',ISLENT*100,*999)
+#else
+      if (NTRY.GT.NETRY) then
+          call hwwarn('HWBGEN',ISLENT*100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       NRHEP=0
       NHEP=LASHEP
       FROST=.FALSE.
@@ -51,8 +68,13 @@
         DO 15 J=1,2
         DO 15 I=1,2
         JMOPAR(I,J)=0
+#if !defined(CERNLIB_GFORTRAN)
    15   JCOPAR(I,J)=0
 C---SET UP EVOLUTION SCALE AND FRAME
+#else
+           JCOPAR(I,J)=0
+   15   continue
+#endif
         JHEP=JMOHEP(2,IHEP)
         IF (ID.EQ.13) THEN
           IF (HWRLOG(HALF)) JHEP=JDAHEP(2,IHEP)
@@ -63,7 +85,12 @@
           IF (ID.LT.7.OR.(ID.GT.208.AND.ID.LT.215)) JHEP=JDAHEP(2,IHEP)
         ENDIF
         IF (JHEP.EQ.0) THEN
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWBGEN',1,*999)
+#else
+          call hwwarn('HWBGEN',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
           JHEP=IHEP
         ENDIF
         JCOPAR(1,1)=JHEP
@@ -176,7 +203,12 @@
       IF (FROST) THEN
 C---BAD JET: RESTORE PARTONS AND RE-EVOLVE
          DO 120 I=1,NRHEP
+#if !defined(CERNLIB_GFORTRAN)
   120    ISTHEP(IRHEP(I))=IRST(I)
+#else
+           ISTHEP(IRHEP(I))=IRST(I)
+  120    continue
+#endif
          GOTO 10
       ENDIF
 C---CONNECT COLOURS
diff -uNr src.ORIG/mclibs/herwig/code/hwbjco.F src/mclibs/herwig/code/hwbjco.F
--- src.ORIG/mclibs/herwig/code/hwbjco.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbjco.F	2005-05-31 02:34:39.000000000 +0900
@@ -7,6 +7,9 @@
 C     COMBINES JETS WITH REQUIRED KINEMATICS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWULDO,EPS,PTX,PTY,PF,PTINF,PTCON,CN,CP,SP,PP0,
      & PM0,ET0,DET,ECM,EMJ,EMP,EMS,DMS,ES,DPF,ALF,AL(2),ET(2),PP(2),
      & PT(3),PB(5),PC(5),PQ(5),PR(5),PS(5),RR(3,3),RS(3,3),ETC,
@@ -38,12 +41,24 @@
           IP1=JDAHEP(1,ICM)
           IP2=JDAHEP(2,ICM)
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (IP1.NE.IP) CALL HWWARN('HWBJCO',100,*999)
+#else
+        if (IP1.NE.IP) then
+          call hwwarn('HWBJCO',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         NP=0
         DO 30 JHEP=IP1,IP2
         NP=NP+1
         IPAR(NP)=JHEP
+#if !defined(CERNLIB_GFORTRAN)
   30    IJET(NP)=JDAHEP(1,JHEP)
+#else
+           IJET(NP)=JDAHEP(1,JHEP)
+  30    continue
+#endif
         GOTO 50
       ENDIF
   40  CONTINUE
@@ -55,7 +70,14 @@
       RETURN
   50  IF (LJET.EQ.131) THEN
 C---SPACELIKE JETS: FIND SPACELIKE PARTONS
+#if !defined(CERNLIB_GFORTRAN)
         IF (NP.NE.2) CALL HWWARN('HWBJCO',103,*999)
+#else
+        if (NP.NE.2) then
+          call hwwarn('HWBJCO',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---special for DIS: FIND BOOST AND ROTATION FROM LAB TO BREIT FRAME
         IF (DISPRO.AND.BREIT) THEN
           IP=2
@@ -63,7 +85,12 @@
           CALL HWVDIF(4,PHEP(1,JMOHEP(1,ICM)),PHEP(1,JDAHEP(1,ICM)),PB)
           CALL HWUMAS(PB)
 C---IF Q**2<10**-2, SOMETHING MUST HAVE ALREADY GONE WRONG
+#if !defined(CERNLIB_GFORTRAN)
           IF (PB(5)**2.LT.1.D-2) CALL HWWARN('HWBJCO',102,*999)
+#else
+          IF (PB(5)**2.LT.1.D-2) call hwwarn('HWBJCO',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
           CALL HWVSCA(4,PB(5)**2/HWULDO(PHEP(1,IP),PB),PHEP(1,IP),PBR)
           CALL HWVSUM(4,PB,PBR,PBR)
           CALL HWUMAS(PBR)
@@ -82,9 +109,19 @@
         ELSE
           IST=134+IP
           DO 60 IHEP=MHEP,NHEP
+#if !defined(CERNLIB_GFORTRAN)
   60      IF (ISTHEP(IHEP).EQ.IST) GOTO 70
 C---COULDN'T FIND SPACELIKE PARTON
+#else
+             IF (ISTHEP(IHEP).EQ.IST) GOTO 70
+  60      continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWBJCO',101,*999)
+#else
+          call hwwarn('HWBJCO',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
   70    CALL HWVSCA(3,PF,PHEP(1,IHEP),PS)
         IF (PTINT(3,IP).GT.0.) THEN
@@ -104,7 +141,12 @@
           PTCON=PR(1)**2+PR(2)**2
           KP=JMOHEP(2,JP)
           IF (KP.EQ.0) THEN
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWBJCO',1,*999)
+#else
+            call hwwarn('HWBJCO',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
             PTINF=0.
           ELSE
             CALL HWVEQU(4,PHEP(1,KP),PB)
@@ -146,13 +188,23 @@
         IEND(IP)=KHEP
         DO 80 JHEP=IHEP,KHEP
         CALL HWUROF(RS,PHEP(1,JHEP),PHEP(1,JHEP))
+#if !defined(CERNLIB_GFORTRAN)
   80    CALL HWUROF(RS,VHEP(1,JHEP),VHEP(1,JHEP))
+#else
+           CALL HWUROF(RS,VHEP(1,JHEP),VHEP(1,JHEP))
+  80    continue
+#endif
         PP(IP)=PHEP(4,IHEP)+PF*PHEP(3,IHEP)
         ET(IP)=PHEP(1,IHEP)**2+PHEP(2,IHEP)**2-PHEP(5,IHEP)**2
 C---REDEFINE HARD CM
         PTX=PTX+PHEP(1,IHEP)
         PTY=PTY+PHEP(2,IHEP)
+#if !defined(CERNLIB_GFORTRAN)
   90    PF=-PF
+#else
+           PF=-PF
+  90    continue
+#endif
         PHEP(1,ICM)=PTX
         PHEP(2,ICM)=PTY
 C---special for DIS: keep lepton momenta fixed
@@ -217,10 +269,20 @@
             CALL HWUROB(RBR,VHEP(1,IHEP),VHEP(1,IHEP))
             CALL HWULB4(PBR,VHEP(1,IHEP),VHEP(1,IHEP))
           ENDIF
+#if !defined(CERNLIB_GFORTRAN)
   100     ISTHEP(IHEP)=ISTHEP(IHEP)+10
+#else
+            ISTHEP(IHEP)=ISTHEP(IHEP)+10
+  100     continue
+#endif
           CALL HWVDIF(4,VHEP(1,IPAR(2)),VHEP(1,IJET(2)),DISP)
           DO 110 IHEP=IJET(2),IEND(2)
+#if !defined(CERNLIB_GFORTRAN)
   110     CALL HWVSUM(4,DISP,VHEP(1,IHEP),VHEP(1,IHEP))
+#else
+            CALL HWVSUM(4,DISP,VHEP(1,IHEP),VHEP(1,IHEP))
+  110     continue
+#endif
           IF (IEND(2).GT.IJET(2)+1) ISTHEP(IJET(2)+1)=100
           CALL HWVSUM(4,PHEP(1,IJT),PHEP(1,IJET(2)),PC)
           CALL HWVSUM(4,PHEP(1,IP1),PHEP(1,IJET(2)),PHEP(1,ICM))
@@ -244,10 +306,20 @@
            DO 120 IHEP=IJT,IEND(2)
            CALL HWULOF(PB,PHEP(1,IHEP),PHEP(1,IHEP))
            CALL HWULF4(PB,VHEP(1,IHEP),VHEP(1,IHEP))
+#if !defined(CERNLIB_GFORTRAN)
   120      ISTHEP(IHEP)=ISTHEP(IHEP)+10
+#else
+             ISTHEP(IHEP)=ISTHEP(IHEP)+10
+  120      continue
+#endif
            CALL HWVDIF(4,VHEP(1,IPAR(2)),VHEP(1,IJT),DISP)
            DO 130 IHEP=IJT,IEND(2)
+#if !defined(CERNLIB_GFORTRAN)
   130      CALL HWVSUM(4,DISP,VHEP(1,IHEP),VHEP(1,IHEP))
+#else
+             CALL HWVSUM(4,DISP,VHEP(1,IHEP),VHEP(1,IHEP))
+  130      continue
+#endif
            IF (IEND(2).GT.IJT+1) ISTHEP(IJT+1)=100
            ISTHEP(IJET(1))=ISTHEP(IJET(1))+10
            CALL HWVSUM(2,PHEP(3,IPAR(1)),PHEP(3,IJT),PHEP(3,ICM))
@@ -275,10 +347,20 @@
           DO 140 IHEP=IJT,IEND(IP)
           CALL HWULOF(PB,PHEP(1,IHEP),PHEP(1,IHEP))
           CALL HWULF4(PB,VHEP(1,IHEP),VHEP(1,IHEP))
+#if !defined(CERNLIB_GFORTRAN)
   140     ISTHEP(IHEP)=ISTHEP(IHEP)+10
+#else
+            ISTHEP(IHEP)=ISTHEP(IHEP)+10
+  140     continue
+#endif
           CALL HWVDIF(4,VHEP(1,IPAR(IP)),VHEP(1,IJT),DISP)
           DO 150 IHEP=IJT,IEND(IP)
+#if !defined(CERNLIB_GFORTRAN)
   150     CALL HWVSUM(4,DISP,VHEP(1,IHEP),VHEP(1,IHEP))
+#else
+            CALL HWVSUM(4,DISP,VHEP(1,IHEP),VHEP(1,IHEP))
+  150     continue
+#endif
           IF (IEND(IP).GT.IJT+1) THEN
             ISTHEP(IJT+1)=100
           ELSEIF (IEND(IP).EQ.IJT) THEN
@@ -302,7 +384,12 @@
           PQ(5)=PHEP(5,ICM)
           IF (NP.GT.2) THEN
             DO 170 KP=3,NP
+#if !defined(CERNLIB_GFORTRAN)
   170       CALL HWVSUM(4,PHEP(1,IPAR(KP)),PQ,PQ)
+#else
+              CALL HWVSUM(4,PHEP(1,IPAR(KP)),PQ,PQ)
+  170       continue
+#endif
           ENDIF
           LP=1
         ENDIF
@@ -319,7 +406,17 @@
           PM(KP)= EMJ**2
 C---N.B. ROUNDING ERRORS HERE AT HIGH ENERGIES
           PJ(KP)=(HWULDO(PHEP(1,IPAR(KP)),PQ)/ECM)**2-EMP**2
+#if !defined(CERNLIB_GFORTRAN)
+#if !defined(CERNLIB_GFORTRAN)
   180     IF (PJ(KP).LE.0.) CALL HWWARN('HWBJCO',104,*999)
+#else
+            IF (PJ(KP).LE.0.) CALL HWWARN('HWBJCO',104,*999)
+  180     continue
+#endif
+#else
+  180     IF (PJ(KP).LE.0.) call hwwarn('HWBJCO',104,iret)
+        if (iret .eq. 1) go to 999
+#endif
           PF=1.
           IF (JETRAD) THEN
 C---JETS DID RADIATE
@@ -333,12 +430,27 @@
             DO 190 KP=LP,NP
             ES=SQRT(PF*PJ(KP)+PM(KP))
             EMS=EMS+ES
+#if !defined(CERNLIB_GFORTRAN)
   190       DMS=DMS+PJ(KP)/ES
+#else
+              DMS=DMS+PJ(KP)/ES
+  190       continue
+#endif
             DPF=2.*EMS/DMS
             IF (DPF.GT.PF) DPF=0.9*PF
             PF=PF-DPF
+#if !defined(CERNLIB_GFORTRAN)
   200       IF (ABS(DPF).LT.EPS) GOTO 210
+#else
+              IF (ABS(DPF).LT.EPS) GOTO 210
+  200       continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWBJCO',105,*999)
+#else
+            call hwwarn('HWBJCO',105,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ENDIF
   210     CONTINUE
         ENDIF
@@ -378,7 +490,12 @@
           CALL HWUROT(PR, ONE,ZERO,RS)
           JP=JMOHEP(2,KP)
           IF (JP.EQ.0) THEN
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWBJCO',2,*999)
+#else
+            call hwwarn('HWBJCO',2,iret)
+        if (iret .eq. 1) go to 999
+#endif
             PTINF=0.
           ELSE
             CALL HWVEQU(4,PHEP(1,JP),PS)
@@ -445,7 +562,12 @@
           CALL HWULB4(PBR,VHEP(1,JHEP),VHEP(1,JHEP))
         ENDIF
         CALL HWVSUM(4,VHEP(1,JHEP),VHEP(1,IPAR(IP)),VHEP(1,JHEP))
+#if !defined(CERNLIB_GFORTRAN)
   220   ISTHEP(JHEP)=ISTHEP(JHEP)+10
+#else
+          ISTHEP(JHEP)=ISTHEP(JHEP)+10
+  220   continue
+#endif
         IF (KHEP.GT.IHEP+1) THEN
           ISTHEP(IHEP+1)=100
         ELSEIF (KHEP.EQ.IHEP) THEN
diff -uNr src.ORIG/mclibs/herwig/code/hwbmas.F src/mclibs/herwig/code/hwbmas.F
--- src.ORIG/mclibs/herwig/code/hwbmas.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbmas.F	2005-05-31 02:34:39.000000000 +0900
@@ -64,7 +64,12 @@
   10     CONTINUE
       ENDIF
       DO 20 IPAR=2,NPAR
+#if !defined(CERNLIB_GFORTRAN)
   20  PPAR(5,IPAR)=HWUSQR(PPAR(5,IPAR))
+#else
+         PPAR(5,IPAR)=HWUSQR(PPAR(5,IPAR))
+  20  continue
+#endif
       PPAR(1,2)=0.
       PPAR(2,2)=0.
       END
